<?php

class Dap_UserCredits extends Dap_Base {

   	var $user_id;
   	var $product_id;
   	var $credits_earned;
   	var $credits_spent;
   	var $datetime;
   	var $comments;
	
			
		function getUser_id()  {
	       return $this->user_id;
		}
		function setUser_id($o) {
	      $this->user_id = $o;
		}	
		
		function getProduct_id()  {
	       return $this->product_id;
		}
		function setProduct_id($o) {
	      $this->product_id = $o;
		}	
			
		function getCredits_earned()  {
	       return $this->credits_earned;
		}
		function setCredits_earned($o) {
	      $this->credits_earned = $o;
		}	
	
		function getCredits_spent()  {
	       return $this->credits_spent;
		}
		function setCredits_spent($o) {
	      $this->credits_spent = $o;
		}	
		
	public static function addCredits($userId, $productId, $transactionId, $creditsEarned, $creditsSpent, $comments="Self-Service", $masterProductId="", $resourceId="") {
		try {
			logToFile("In SSS addCredits",LOG_DEBUG_DAP); 
			$sql = "";
			
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction(); //begin the transaction
				
			logToFile("In addCredits userId=".$userId,LOG_DEBUG_DAP); 
			logToFile("In addCredits creditsEarned=".$creditsEarned,LOG_DEBUG_DAP); 
			logToFile("In addCredits creditsSpent=".$creditsSpent,LOG_DEBUG_DAP); 
			logToFile("In addCredits productId=".$productId,LOG_DEBUG_DAP); 
			logToFile("In addCredits resourceId=".$resourceId,LOG_DEBUG_DAP); 
			
			$usercred = Dap_UserCredits::loadCreditsPerResource($userId, $productId, $resourceId);
			
			if (($usercred != null) && ($usercred != "")) {
				logToFile("usercredit row exists",LOG_DEBUG_DAP); 
				
				if (($usercred->getCredits_earned() != "") && ($usercred->getCredits_earned() > 0) && ($comments != "By Admin")) 
					$creditsEarnedNew = $creditsEarned + $usercred->getCredits_earned();
				
				if (($usercred->getCredits_spent() != "") && ($usercred->getCredits_spent() > 0) && ($comments != "By Admin")) 
					$creditsSpentNew = $creditsSpent + $usercred->getCredits_spent();
					
				if (intval($creditsEarned) != 0) {			
					logToFile("update creditsEarned=".$creditsEarnedNew,LOG_DEBUG_DAP); 
					$sql = "update dap_users_credits set credits_earned = :credits_earned where user_id = :user_id and product_id = :product_id and resource_id=:resource_id";	
					logToFile("update sql=".$sql,LOG_DEBUG_DAP); 
					$stmt = $dap_dbh->prepare($sql);
					$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
					$stmt->bindParam(':product_id', $productId, PDO::PARAM_INT);
					$stmt->bindParam(':resource_id', $resourceId, PDO::PARAM_INT);
					$stmt->bindParam(':credits_earned', $creditsEarnedNew, PDO::PARAM_INT);
					$stmt->execute();
					
				}
				else if (intval($creditsSpent) != 0) {	
					logToFile("update creditsSpent=".$creditsSpentNew,LOG_DEBUG_DAP); 
					$sql = "update dap_users_credits set credits_spent = :credits_spent where user_id = :user_id and product_id = :product_id  and resource_id=:resource_id";
					logToFile("update sql=".$sql,LOG_DEBUG_DAP); 
					$stmt = $dap_dbh->prepare($sql);
					$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
					$stmt->bindParam(':product_id', $productId, PDO::PARAM_INT);
					$stmt->bindParam(':resource_id', $resourceId, PDO::PARAM_INT);
					$stmt->bindParam(':credits_spent', $creditsSpentNew, PDO::PARAM_INT);
					$stmt->execute();
				}
				
			
				logToFile("update complete",LOG_DEBUG_DAP); 
			}
			else {
								 
				//Next add to credits history
				$sql = "insert into 
							dap_users_credits 
						set
							user_id =:user_id,
							product_id =:product_id,
							resource_id=:resource_id,
							transaction_id =:transaction_id,
							credits_earned =:credits_earned,
							credits_spent =:credits_spent,
							datetime = now(),
							comments =:comments
						";
				
				//logToFile("SSS: $sql",LOG_DEBUG_DAP); 
				$stmt = $dap_dbh->prepare($sql);
				$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
				$stmt->bindParam(':product_id', $productId, PDO::PARAM_INT);
				$stmt->bindParam(':resource_id', $resourceId, PDO::PARAM_INT);
				$stmt->bindParam(':transaction_id', $transactionId, PDO::PARAM_INT);
				$stmt->bindParam(':credits_earned', $creditsEarned, PDO::PARAM_INT);
				$stmt->bindParam(':credits_spent', $creditsSpent, PDO::PARAM_INT);
				$stmt->bindParam(':comments', $comments, PDO::PARAM_STR);
				$stmt->execute();
			}
			$dap_dbh->commit(); //commit the transaction
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	



	public static function addCreditsAtProductLevel($userId, $productId, $transactionId, $creditsEarned, $creditsSpent, $comments="Self-Service", $masterProductId="") {
		try {
			logToFile("In SSS addCredits",LOG_DEBUG_DAP); 
			$sql = "";
			
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction(); //begin the transaction
				
			logToFile("In addCredits userId=".$userId,LOG_DEBUG_DAP); 
			logToFile("In addCredits creditsEarned=".$creditsEarned,LOG_DEBUG_DAP); 
			logToFile("In addCredits creditsSpent=".$creditsSpent,LOG_DEBUG_DAP); 
			logToFile("In addCredits productId=".$productId,LOG_DEBUG_DAP); 
			
			$usercred = Dap_UserCredits::loadCreditsPerProduct($userId, $productId);
			
			if (($usercred != null) && ($usercred != "")) {
				logToFile("usercredit row exists",LOG_DEBUG_DAP); 
				
				if (($usercred->getCredits_earned() != "") && ($usercred->getCredits_earned() > 0) && ($comments != "By Admin")) 
					$creditsEarnedNew = $creditsEarned + $usercred->getCredits_earned();
				
				if (($usercred->getCredits_spent() != "") && ($usercred->getCredits_spent() > 0) && ($comments != "By Admin")) 
					$creditsSpentNew = $creditsSpent + $usercred->getCredits_spent();
					
				if (intval($creditsEarned) != 0) {			
					logToFile("update creditsEarned=".$creditsEarnedNew,LOG_DEBUG_DAP); 
					$sql = "update dap_users_credits set credits_earned = :credits_earned where user_id = :user_id and product_id = :product_id and resource_id=0";	
					logToFile("update sql=".$sql,LOG_DEBUG_DAP); 
					$stmt = $dap_dbh->prepare($sql);
					$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
					$stmt->bindParam(':product_id', $productId, PDO::PARAM_INT);
					$stmt->bindParam(':credits_earned', $creditsEarnedNew, PDO::PARAM_INT);
					$stmt->execute();
					
				}
				else if (intval($creditsSpent) != 0) {	
					logToFile("update creditsSpent=".$creditsSpentNew,LOG_DEBUG_DAP); 
					$sql = "update dap_users_credits set credits_spent = :credits_spent where user_id = :user_id and product_id = :product_id and resource_id=0";
					logToFile("update sql=".$sql,LOG_DEBUG_DAP); 
					$stmt = $dap_dbh->prepare($sql);
					$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
					$stmt->bindParam(':product_id', $productId, PDO::PARAM_INT);
					$stmt->bindParam(':credits_spent', $creditsSpentNew, PDO::PARAM_INT);
					$stmt->execute();
				}
				
			
				logToFile("update complete",LOG_DEBUG_DAP); 
			}
			else {
								 
				//Next add to credits history
				$sql = "insert into 
							dap_users_credits 
						set
							user_id =:user_id,
							product_id =:product_id,
							transaction_id =:transaction_id,
							credits_earned =:credits_earned,
							credits_spent =:credits_spent,
							datetime = now(),
							comments =:comments
						";
				
				//logToFile("SSS: $sql",LOG_DEBUG_DAP); 
				$stmt = $dap_dbh->prepare($sql);
				$stmt->bindParam(':user_id', $userId, PDO::PARAM_INT);
				$stmt->bindParam(':product_id', $productId, PDO::PARAM_STR);
				$stmt->bindParam(':transaction_id', $transactionId, PDO::PARAM_INT);
				$stmt->bindParam(':credits_earned', $creditsEarned, PDO::PARAM_INT);
				$stmt->bindParam(':credits_spent', $creditsSpent, PDO::PARAM_INT);
				$stmt->bindParam(':comments', $comments, PDO::PARAM_STR);
				$stmt->execute();
			}
			$dap_dbh->commit(); //commit the transaction
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	public static function addMasterCredits($userId, $transactionId, $creditsSpent, $masterProductId) {
		try {
			logToFile("In SSS addCredits",LOG_DEBUG_DAP); 
						
			logToFile("In addMasterCredits creditsSpent=".$creditsSpent,LOG_DEBUG_DAP); 
			logToFile("In addMasterCredits masterProductId=".$masterProductId,LOG_DEBUG_DAP); 
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "update dap_users_credits set credits_spent = credits_spent + " . $creditsSpent . " where user_id = $userId and product_id = $masterProductId";
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			//$dap_dbh->commit(); //commit the transaction
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	//For a given user, load credit history
	public static function loadCreditHistory($userId) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$creditHistoryArray = array();
			$sql = "SELECT 
						uc.user_id,
						uc.product_id,
						uc.product_id as productIdArray,
						uc.resource_id,
						uc.transaction_id,
						uc.credits_earned,
						uc.credits_spent,
						uc.datetime,
						uc.comments
					FROM 
						dap_users_credits uc
					WHERE
						uc.user_id = :userId and
						(uc.credits_spent > 0 or
						uc.credits_earned > 0)
					order by 
						datetime desc";

			logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':userId', $userId, PDO::PARAM_INT);
			$stmt->execute();	
			
			while($obj = $stmt->fetch(PDO::FETCH_OBJ)) {
				if( !is_null($obj->productIdArray) && ($obj->productIdArray != "") && ($obj->productIdArray != 0) ) {
					$productIds = explode(",", $obj->productIdArray);
					$productName = "";
					foreach($productIds as $productId) {
						$product = Dap_Product::loadProduct($productId);
						if ($product) {
							$productName = $product->getName() . ", " . $productName;
						}
						else continue;
					}
					$obj->name = trim($productName,", ");
				} else {
					$obj->name = "";
				}
								
				if($obj->credits_earned == 0) $obj->credits_earned = "";
				if($obj->credits_spent == 0) $obj->credits_spent = "";
				if ($obj->name != "")
					$creditHistoryArray[] = $obj;
			}
			
			$stmt = null;
			$dap_dbh = null;
			
			return $creditHistoryArray;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}


	public static function addCreditsToUser($email, $credits) {
		try {
			logToFile("In SSS addCreditsToUser",LOG_DEBUG_DAP); 
			
			$user = Dap_User::loadUserByEmail($email); //load user object
			Dap_UserCredits::addCredits($user->getId(), 0, -3, $credits, 0, "Admin added");
			
			return;
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	
	//For a given user, load products that user does NOT have access to
	public static function loadCreditsPerProduct($userId, $productId) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
				duc.credits_earned, duc.credits_spent 
			FROM 
				dap_users_credits duc
			where
				duc.product_id = :productId and
				duc.user_id = :userId";
				
			//logToFile($sql,LOG_DEBUG_DAP);
			$usercredits="";
			
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':userId', $userId, PDO::PARAM_INT);
			$stmt->bindParam(':productId', $productId, PDO::PARAM_INT);
			
			$stmt->execute();	
						
			if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$usercredits = new Dap_UserCredits();
				$usercredits->setCredits_spent($row["credits_spent"]);
				$usercredits->setCredits_earned($row["credits_earned"]);
				$stmt = null;
				$dap_dbh = null;
			
				return $usercredits;
			}
					
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}	


	//For a given user, load products that user does NOT have access to
	public static function loadCreditsPerResource($userId, $productId, $resourceId) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
				duc.credits_earned, duc.credits_spent 
			FROM 
				dap_users_credits duc
			where
				duc.product_id = :productId and
				duc.user_id = :userId and
				duc.resource_id = :resourceId";
				
			//logToFile($sql,LOG_DEBUG_DAP);
			$usercredits="";
			
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':userId', $userId, PDO::PARAM_INT);
			$stmt->bindParam(':productId', $productId, PDO::PARAM_INT);
			$stmt->bindParam(':resourceId', $resourceId, PDO::PARAM_INT);
				
			$stmt->execute();	
						
			if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$usercredits = new Dap_UserCredits();
				$usercredits->setCredits_spent($row["credits_spent"]);
				$usercredits->setCredits_earned($row["credits_earned"]);
				$stmt = null;
				$dap_dbh = null;
			
				return $usercredits;
			}
					
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}	

}
?>
