<?php
	include_once ("dap-config.php");	
	
	/*
		Three possible use cases.
		1) New member, new product association
		2) Existing member, new product
		3) Existing member, old product (don't extend)
	*/

	//Core "User" data
	$first_name = isset($_POST['first_name']) ? addslashes($_POST['first_name']) : "";
	$last_name = isset($_POST['last_name']) ? addslashes($_POST['last_name']) : "";
	$user_name = isset($_POST['user_name']) ? addslashes($_POST['user_name']) : "";
	$email = isset($_POST['email']) ? addslashes($_POST['email']) : "";
	//$password = isset($_POST['password']) ? addslashes($_POST['password']) : "";
	$address1 = isset($_POST['address1']) ? addslashes($_POST['address1']) : "";
	$address2 = isset($_POST['address2']) ? addslashes($_POST['address2']) : "";
	$city = isset($_POST['city']) ? addslashes($_POST['city']) : "";
	$state = isset($_POST['state']) ? addslashes($_POST['state']) : "";
	$zip = isset($_POST['zip']) ? addslashes($_POST['zip']) : "";
	$country = isset($_POST['country']) ? addslashes($_POST['country']) : "";
	$phone = isset($_POST['phone']) ? addslashes($_POST['phone']) : "";
	$fax = isset($_POST['fax']) ? addslashes($_POST['fax']) : "";
	$company = isset($_POST['company']) ? addslashes($_POST['company']) : "";
	$title = isset($_POST['title']) ? addslashes($_POST['title']) : "";
	$paypal_email = isset($_POST['paypal_email']) ? addslashes($_POST['paypal_email']) : "";
	
	logToFile("signup_submit.php:  paypal_email=". $paypal_email, LOG_FATAL_DAP);
	
	//Non-user data
	if (isset($_POST['coupon_code'])) {
		if ($_POST['coupon_code'] == "") {
			header("Location:error.php?msg=Sorry, coupon code is a required field. Please go 'back' and enter a valid coupon code.");
			exit;	
		}
	}
	
	$coupon_code = isset($_POST['coupon_code']) ? addslashes($_POST['coupon_code']) : "";
	$productId = isset($_POST['productId']) ? addslashes($_POST['productId']) : "";
						
	if( $coupon_code != "" ) {
		if (validateCouponCode($productId, $coupon_code) == false ) {
			header("Location:error.php?msg=Sorry, the coupon code you entered is invalid. Please go 'back' and enter a valid coupon code.");
			exit;
		} else {
			if (!updateUsage($coupon_code)) {
				logToFile("signup_submit.php: Failed to update coupon actual usage of coupon code: $coupon_code",LOG_FATAL_DAP);
			}
		}
		
		$coupon = Dap_Coupon::loadCouponByCode($coupon_code); //loads coupon details from db
		$couponId = $coupon->getId();
	}	
	
	$ipaddress = getIpOfUser();
	$thirdParty = true;
	$redirect = isset($_POST['redirect']) ? addslashes($_POST['redirect']) : "";
	if($redirect == "") {
		$redirect = Dap_Config::get("LOGIN_URL");
		$thirdParty = false;
	}
	$redirURL = "";
	$msg = "SUCCESS! Thank you for signing up. Please check your email for further details.";
	$user = null;
	
	//Basic validation
	if( ($first_name == "") || 
		($email == "") || 
		($productId == "") || 
		strpos($_POST['email'], "\r") || 
		strpos($_POST['email'], "\n") || 
		( isset($_POST['user_name']) && ($_POST['user_name'] == "") )  
	) {
		header("Location:error.php?msg=Sorry, all fields are mandatory. Please go 'back' and fill up the missing information.");
		exit;
	}
	if( validateEmailFormat($email) === false ) {
		header("Location:error.php?msg=Sorry, the email address you entered is invalid. Please go 'back' and enter a valid email address.");
		exit;
	}
	
	
	try {
		
		$user = new Dap_User();
		$user->setFirst_name($first_name);
		$user->setLast_name($last_name);
		$user->setUser_name($user_name);
		$user->setEmail($email);
		//$user->setPassword($password);
		$user->setAddress1($address1);
		$user->setAddress2($address2);
		$user->setCity($city);
		$user->setState($state);
		$user->setZip($zip);
		$user->setCountry($country);
		$user->setPhone($phone);
		$user->setFax($fax);
		$user->setCompany($company);
		$user->setTitle($title);
		$user->setPaypal_email($paypal_email);
		
		$user = Dap_UsersProducts::directSignupSubmit($user, $coupon_code, $productId, $couponId);
	
		
		if(isset($user)) {
			$uid = $user->getId();
			$_SESSION['uid'] = $uid;
			$_SESSION['AFF_LINK'] = SITE_URL_DAP . "/dap/a/?a=".$uid;
			
				// check if custom field present
			foreach($_REQUEST as $key=>$value)
			{
				logToFile("signup_submit.php: key=" . $key . " value=" . $value, LOG_DEBUG_DAP);		
					
				if (strstr($key, "custom_")) {	
					if ($keyval = substr($key, 7)) {
							
						$customFld = Dap_CustomFields::loadCustomfieldsByName($keyval);
						logToFile("signup_submit.php: loadCustomfieldsByName(): keyval=" . $keyval, LOG_DEBUG_DAP);		
						
						if ($customFld) {
							$id = $customFld->getId();
							logToFile("signup_submit.php: customFld Id = " . $id, LOG_DEBUG_DAP);		
							
							$usercustom = new Dap_UserCustomFields();
							
							$usercustom->setUser_id($uid);
							$usercustom->setCustom_id($id);
							$usercustom->setCustom_value($value);
							
							$cf = Dap_UserCustomFields::loadUserCustomFieldsByCustomFieldId($id, $uid);
							if ($cf) {
								logToFile("signup_submit.php: call update() to update value=" . $value, LOG_DEBUG_DAP);
								$usercustom->update();
							}
							else {
								logToFile("signup_submit.php: call create() to add custom value=" . $nv[1], LOG_DEBUG_DAP);
								$usercustom->create();
							}
						}
					}
				}
			}
		}
		
		//Load full user and update other info if available
		//$user = Dap_User::loadUserById($uid);
		
	} catch (PDOException $e) {
		logToFile($e->getMessage(),LOG_FATAL_DAP);
		$msg = $e->getMessage();
	} catch (Exception $e) {
		logToFile($e->getMessage(),LOG_FATAL_DAP);
		$msg = $e->getMessage();
	}		
	
	//Redirect to 'redirect' (if available) or member home page
	if($thirdParty == true) {
		$redirURL = $redirect;
	} else {
		$redirURL =  $redirect . "?msg=" . $msg;
	}
	header("Location: " . $redirURL);
	exit;
?>