<?php 
/*	  1. read product info from products
2. read post params into variables
3. if missing form input, replace from products
4. if no session, display form with pre-filled values and editable text box
5. if session, submit to paymentsubmit.php*/

$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
if(file_exists($lldocroot . "/dap/dap-config.php")) include_once ($lldocroot . "/dap/dap-config.php");
if(file_exists($lldocroot . "/dap/securimage.php")) include_once ($lldocroot . "/dap/securimage.php");
if(file_exists($lldocroot . "/dap/set-payment-params.php")) include_once ($lldocroot . "/dap/set-payment-params-checkout.php");



$user = Dap_User::loadAdminUserByMinId();
if (!isset($user)) {
		$error_url = "Sorry, Admin setup issue. Please contact the site-admin";
		return $error_url;
}
	
$password = $user->getPassword();
if (!isset ($password) || $password == '') {
	$error_url = "Sorry, Admin setup issue. Please contact the site-admin";
	return $error_url;
}

$_SESSION['password'] = $password;

$product = Dap_Product::loadProductByName(trim($item_name));
$item_name = $product->getName();
$description = $product->getDescription();

$trial_amount = $product->getTrial_price();
$amount = $product->getPrice();

$is_recurring = $product->getIs_recurring();

$recurring_cycle_1 = $product->getRecurring_cycle_1();
$recurring_cycle_2 = $product->getRecurring_cycle_2();
$recurring_cycle_3 = $product->getRecurring_cycle_3();
$total_occurrences = $product->getTotal_occur();
	
if (isset($trial_amount) && $trial_amount != '' && $trial_amount != "0.00" && $trial_amount != "0.0" && $trial_amount != "0" ) {
	$display_amount=$trial_amount;
}
else {
	$display_amount=$amount;
	$trial_amount = "0.00";
}
	
$invoice = date(YmdHis);	
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<html>
<head>
<title>Payment Form</title>
<?php getCheckoutCss(); ?>
<link rel='stylesheet' type='text/css' href='/dap/inc/content/dap.css'>
<link rel='stylesheet' type='text/css' href='/dap/inc/content/PaymentForm.css'>
<script type='text/javascript' language='javascript' src="javascript/country-state.js"></script>
<script type='text/javascript' language='javascript' src="javascript/common.js"></script>
<script type='text/javascript' language='javascript' src="javascript/paymentvalidation.js"></script>
<script type="text/javascript" language="javascript">
	function initCardType() {
		var cardtype = document.getElementById('card_type');
		if (cardtype != null) {
			var val = 
			"<?php 
				if (isset($_SESSION['paymentObj'])) {
					$cardt = $_SESSION['paymentObj']->getCard_type(); 
					if ($cardt != '')
					{ 
						echo $cardt; 
					}
					else echo '';
				}
			?>";
		
			if (val != null && val != '') {
                //cardtype.options[cardtype.selectedIndex].text = val;
            for(i=0; i<cardtype.options.length; i++) {
               if(cardtype.options[i].value == val) {
                    cardtype.selectedIndex = i;
               }
            }
         }
			
		}
	}
		
</script>
</head>
<body onLoad="onPageLoad();">
<?php if(file_exists("inc/cartheader.php")) include ("inc/cartheader.php"); ?>
<center>
  <div id="divPage" style="border: #828282 2px solid; padding: 5px; width:600px; text-align:left;">
    <!-- Error Text Div -->
    <div id="errorText" style="color:#F00;font-size:14px;">
      <table width='100%' height="70" id=tableHead>
        <tr>
          <td style="color:#F00;font-size:14px"><b>
            <?php if (isset($_SESSION['err_text'])) echo "<blink>ERROR:</blink> " . $_SESSION['err_text']; $_SESSION['err_text'] = NULL; ?>
            </b></td>
        </tr>
        <tr>
          <td height="43" align="center" class=LabelHeading><h3>Checkout =&gt; Confirmation</h3></td>
        </tr>
		<tr>
		<td align="right"><img src="images/secure-padlock.gif" alt="Your order is secure">
		<span class=Comment><a id="aCardCodeWhatsThis" href="inc/content/secure.html" onclick='javascript:return PopupLink(this);'>Your order is secure</a></span>
		</td>		
		</tr>
      </table>
    </div>
    <!-- END: Error Text Div -->
    
    
   <form name="formPayment" id="formPayment" autocomplete="off" method="post" action="buy-submit.php">
   
   
   <!-- Product Information Div -->
   <fieldset>
	<legend>Product Information</legend>
      <div id="divOrderDetailsTop" width="100%">
         <table id="tableOrderDetailsTop">
          <tr valign="top">
            <td nowrap class="LabelColOrderTop"><div align="left">Product:</div></td>
            <td class=DataColOrderTop><div align="left"><?php echo $item_name; ?></div></td>
            <td rowspan="4" valign="top" nowrap class="DataColOrderTop">
            </td>
          </tr>
          <tr valign="top">
            <td nowrap class="LabelColOrderTop"><div align="left">Description: </div></td>
            <td class=DataColOrderTop><div align="left"><?php echo $description; ?> &nbsp;<br/>
              </div></td>
          </tr>
		  
		   <tr valign="top">
              <td align="right" class="DataColOrderTop" colspan="2"><h3><div align="right">Total: 
  				<?php echo "$ " . $display_amount; 
				?>
              </h3></div></td>
            </tr>
			
		 
		</table>
        <!-- tableOrderDetailsTop -->
      </div>
    </fieldset>
    <!-- END: Product Information Div -->

    
    <!-- Product Information Div -->
	<fieldset>
    <legend>Payment Information</legend>
      <div id="divCreditCardInformation" align="left" width='100%'>
        <table id="tableCreditCardInformation">
          <tr id="trAcceptedCardImgs">
            <td class="LabelColCC">&nbsp;</td>
            <td><img border="0" src="images/V.gif" width="43" height="26" title="Visa" alt="Visa"></img> <img border="0" src="images/MC.gif" width="41" height="26" title="MasterCard" alt="MasterCard"></img> <img border="0" src="images/Amex.gif" width="40" height="26" title="American Express" alt="American Express"></img> <img border="0" src="images/Disc.gif" width="40" height="26" title="Discover" alt="Discover"></img></td>
          </tr>
	
		<?php if ($payment_gateway == "paypal") {
			echo "<tr>";
			echo "<td valign='top' class='LabelColCC'>Card Type:&nbsp;</td>";
			echo "<td valign='top'>";
			echo "<select id='card_type' name='card_type' style='width: 190px;font-size: 14px;'>";
			echo "<option value='Visa' selected>Visa</option>";
			echo "<option value='MasterCard'>MasterCard</option>";
			echo "<option value='Discover'>Discover</option>";
			echo "<option value='Amex'>American Express</option>";
			echo "</select>	</td> </tr>";
		}
		?>

          <tr>
            <td valign="top" class="LabelColCC">Card Number: </td>
            <td valign="top"><input type="text" class="input_text" id="card_num" name="card_num" maxlength="16" size="18" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getCard_num(); ?>" >
              *&nbsp;<span class="Comment">(enter number without spaces or dashes)</span></td>
          </tr>
          <tr>
            <td valign="top" class=LabelColCC>Expiration Date: </td>
            <td valign="top"><input type="text" class="input_text" id="exp_date" name="exp_date" maxLength="20" size="18" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getExp_date(); ?>" >
              *&nbsp;<span class=Comment>(mmyy)</span></td>
          </tr>
          <tr>
            <td valign="top" class=LabelColCC>Card Code: </td>
            <td valign="top"><input type="text" class="input_text" id="card_code" name="card_code" maxLength="4" size="4" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getCard_code(); ?>" >
              *&nbsp;<span class=Comment><a id=aCardCodeWhatsThis href="Card_Code.html" target=_blank onclick='javascript:return PopupLink(this);'>What's this?</a></span></td>
          </tr>
        </table>
        <!-- tableCreditCardInformation -->
      </div>
      </fieldset>
      
      

    <!-- Billing Information Div -->
	<fieldset>
    <legend>Billing Information</legend>
    <div id="divBillingInformation" align="left" width='100%'>
        <table id="tableCustomerBillingInformation">
          <tr>
            <td class="LabelColBill">First Name:&nbsp;&nbsp;</td>
            <td class="DataColBill"><input type="text" class="input_text" id="first_name" name="first_name" maxLength="50" size="14" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getFirst_name(); ?>" >
              *&nbsp;<span class="Comment"></span></td>
          </tr>
          <tr>
            <td class="LabelColBill">Last Name:&nbsp;&nbsp;</td>
            <td class=DataColBill><input type="text" class="input_text" id="last_name" name="last_name" maxLength="50" size="14" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getLast_name(); ?>" >
              *&nbsp;<span class=Comment></span></td>
          </tr>
          <tr>
            <td class="LabelColBill">Address:&nbsp;&nbsp;</td>
            <td class=DataColBill><input type="text" class="input_text" id="address" name="address" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getAddress1(); ?>" >
              *&nbsp;<span class=Comment></span></td>
          </tr>
          <tr>
            <td class="LabelColBill">City:&nbsp;&nbsp;</td>
            <td class=DataColBill><input type="text" class="input_text" id="city" name="city" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getCity(); ?>" >
              *&nbsp;<span class=Comment></span></td>
          </tr>
          <tr>
            <td class="LabelColBill">State/Province:&nbsp;&nbsp;</td>
            <td class=DataColBill><select name='state' id='state' STYLE="width: 190px;font-size: 14px;">
              </select>
              &nbsp;<span class=Comment></span></td>
          </tr>
          <tr>
            <td class=LabelColShip>Zip/Postal Code:&nbsp;&nbsp;</td>
            <td class=DataColBill><input type="text" class="input_text" id="zip" name="zip" maxLength="10" size="10" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getZip();?>">
              *&nbsp;<span class=Comment></span></td>
          </tr>
          <tr>
            <td class="LabelColBill">Country:&nbsp;&nbsp;</td>
            <td class=DataColBill><select id="country" name="country" STYLE="width: 190px;font-size: 14px;" onChange="if (document.getElementById('countryvar').value == '') populateState('country', 'state', '', '', '')">
              </select>
              *&nbsp;<span class=Comment></span></td>
            <script type="text/javascript"> 
					var inits ='<?php if (isset($_SESSION['statevar'])) echo $_SESSION['statevar']; else echo ""; ?>';
					var initc= '<?php if (isset($_SESSION['countryvar'])) echo $_SESSION['countryvar']; else echo ""; ?>';
					var initccode= '<?php if (isset($_SESSION['countrycode'])) echo $_SESSION['countrycode']; else echo ""; ?>';
					
					initCountry("US", "country", "state", initc, inits, initccode); 
				</script>
          </tr>
          <tr>
            <td class="LabelColBill">Email:&nbsp;&nbsp;</td>
            <td class=DataColBill><input type="text" class="input_text" id="email" name="email" maxLength="255" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getEmail(); ?>" >
              *&nbsp;<span class=Comment></span></td>
          </tr>
          <tr>
            <td class="LabelColBill">Phone:&nbsp;&nbsp;</td>
            <td class=DataColBill><input type="text" class="input_text" id="phone" name="phone" maxLength="25" size="20" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getPhone(); ?>" >
              *&nbsp;<span class=Comment></span></td>
          </tr>
          <tr>
            <td class="LabelColBill">Fax:&nbsp;&nbsp;</td>
            <td class=DataColBill><input type="text" class="input_text" id="fax" name="fax" maxLength="25" size="20" value="<?php if (	$_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getFax(); ?>" >
              &nbsp;<span class=Comment></span></td>
          </tr>
        </table>
        <!-- tableCustomerBilling -->
      </div>
      </fieldset>
      
    
      <!-- divBillingInformation -->
      <fieldset>
        <legend>Shipping Information</legend>
        <br/>
        <p>
          <input type="checkbox" id="chkCopyBill" onClick="showHideShippingDiv(this.form);">
          &nbsp;Ship to a different address?</p>
        <div id="divShippingInformation" align="left" width='100%' style="display:none">
          <table id=tableCustomerShippingInformation>
            <tr id="trChkCopyBill">
              <td colspan="2"></td>
            </tr>
            <tr>
              <td class="LabelColBill">First Name: </td>
              <td class="DataColBill"><input type="text" id="ship_to_first_name" name="ship_to_first_name" maxLength="50" size="14" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_first_name(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColBill">Last Name: </td>
              <td class="DataColBill"><input type="text" id="ship_to_last_name" name="ship_to_last_name" maxLength="50" size="14" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_last_name(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColShip">Address: </td>
              <td class="DataColShip"><input type="text" id="ship_to_address" name="ship_to_address" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_address1(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <?php 
				if ($show_address2 == "Y") {
				?>
            <tr>
              <td class="LabelColShip">Address2: </td>
              <td class="DataColShip"><input type="text" id="ship_to_address2" name="ship_to_address2" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_address2(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <?php } ?>
            <tr>
              <td class="LabelColShip">City: </td>
              <td class="DataColShip"><input type="text" id="ship_to_city" name="ship_to_city" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_city(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColShip">State/Province: </td>
              <td class="DataColShip"><select id="ship_to_state" name="ship_to_state"  STYLE="width: 190px;font-size: 14px;" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_state(); ?>" >
                </select>
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td align="right" class="LabelColShip">&nbsp;&nbsp;Zip/Postal Code: &nbsp;</td>
              <td class="DataColShip"><input type="text" id="ship_to_zip" name="ship_to_zip" maxLength="10" size="10" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_zip(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColShip">Country: </td>
              <td class="DataColShip"><select id="ship_to_country" name="ship_to_country" STYLE="width: 190px;font-size: 14px;" onChange="populateState('ship_to_country', 'ship_to_state','','','')">
                </select>
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <script type="text/javascript"> 
					var initship ='<?php if (isset($_SESSION['shipstatevar'])) echo $_SESSION['shipstatevar']; else echo ""; ?>';
					var initcountry = '<?php if (isset($_SESSION['shipcountryvar'])) echo $_SESSION['shipcountryvar']; else echo ""; ?>';
					var initcountrycode = '<?php if (isset($_SESSION['shipcountrycode'])) echo $_SESSION['shipcountrycode']; else echo ""; ?>';
					initCountry("US", "ship_to_country", "ship_to_state", initcountry, initship, initcountrycode);
					
			</script>
          </table>
          <!-- tableCustomerShippingInformation -->
        </div>
      </fieldset>
      
      
      <!-- divShippingInformation -->
      <!-- divShippingInformation -->
           <fieldset>
        <legend>Security Code</legend>
        <!-- pass a session id to the query string of the script to prevent ie caching -->
        <div id="divCaptcha">
            <p class="DataColCaptcha" align="left"><img id="x_captcha_signature" name="x_captcha_signature" src="/dap/securimage_show.php?sid=<?php echo md5(uniqid(time())); ?>"></p>
            <p class="DataColCaptcha" align="left">
            	<strong>* Enter security code above: </strong> <input name="code" type="text" value = "" size = "5" maxlength = "5"/>
            </p>
            <p><a href="#" onClick="document.getElementById('x_captcha_signature').src = '/dap/securimage_show.php?sid=' + Math.random(); return false">Reload Image</a></p>
        </div>
      </fieldset>
      <!-- divCaptcha -->
      <hr>
      <table id=tableButtons width='100%'>
        <tr>
          <td class=SpacerRow1 colSpan=2>&nbsp;</td>
        </tr>
        <tr>
          <td width=130><div align="left">
            <input type=reset class="resetbtn" id=btnReset onclick='return reset_onClick();' value='Reset Form' tabindex="1">
          </div></td>
          <td>
            <div align="right">
              <input name="btnSubmit" type="button" class="submitbtn" id="btnSubmit" onclick='onSubmit(this.form);' value = 'Submit Order' tabindex="0">
           </div></td>
        </tr>
      </table>
      
      <input type="hidden" name="description" value="<?php echo $description; ?>">
      <input type="hidden" name="item_name" value="<?php echo $item_name; ?>">
      <input type="hidden" name="product_id" value="<?php echo $productId; ?>">
	  <input type="hidden" name="cmcc_acctnum" value="<?php echo $cmcc_acctnum; ?>">
      <input type="hidden" name="payment_gateway" value="<?php echo $payment_gateway; ?>">
      <input type="hidden" name="payment_succ_page" value="<?php echo $payment_succ_page; ?>">
      <input type="hidden" name="payment_err_page" value="<?php echo $payment_err_page; ?>">
      <input type="hidden" name="amount" value="<?php echo $amount; ?>">
      <input type="hidden" name="trial_amount" value="<?php echo $trial_amount; ?>">
      <input type="hidden" name="total_occurrences" value="<?php echo $total_occurrences; ?>">
      <input type="hidden" name="invoice" value="<?php echo $invoice; ?>">
      <input type="hidden" name="is_recurring" value="<?php echo $is_recurring; ?>">
      <input type="hidden" name="recurring_cycle_1" value="<?php echo $recurring_cycle_1; ?>">
      <input type="hidden" name="recurring_cycle_2" value="<?php echo $recurring_cycle_2; ?>">
      <input type="hidden" name="recurring_cycle_3" value="<?php echo $recurring_cycle_3; ?>">
      <input type="hidden" name="testmode" value="<?php echo $testmode; ?>">
	  <input type="hidden" id='cardtype' name="cardtype" value="">
      <input type="hidden" id='statevar' name="statevar" value="">
	  <input type="hidden" id='statecode' name="statecode" value="">
      <input type="hidden" id='countryvar' name="countryvar" value="">
      <input type="hidden" id='countrycode' name="countrycode" value="">
      <input type="hidden" id='shipstatevar' name="shipstatevar" value="">
	  <input type="hidden" id='shipstatecode' name="shipstatecode" value="">
      <input type="hidden" id='shipcountryvar' name="shipcountryvar" value="">
      <input type="hidden" id='shipcountrycode' name="shipcountrycode" value="">
      <input type="hidden" name="is_submitted" value="<?php echo $is_submitted; ?>">

    </form>
  </div>
  <!-- entire BODY -->
</center>
<?php if(file_exists("inc/cartfooter.php")) include ("inc/cartfooter.php"); ?>
</body>
</html>