<?php 
/*	
	1. read product info from products
	2. read post params into variables
	3. if missing form input, replace from products
	4. if no session, display form with pre-filled values and editable text box
	5. if session, submit to paymentsubmit.php
*/

$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
if(file_exists($lldocroot . "/dap/dap-config.php")) include_once ($lldocroot . "/dap/dap-config.php");
if(file_exists($lldocroot . "/dap/inc/classes/Dap_CartOptions.class.php")) 
	include_once ($lldocroot . "/dap/inc/classes/Dap_CartOptions.class.php");

if(file_exists($lldocroot . "/dap/securimage.php")) include_once ($lldocroot . "/dap/securimage.php");
if(file_exists($lldocroot . "/dap/set-payment-params-checkout.php")) include_once ($lldocroot . "/dap/set-payment-params-checkout.php");


$btntype = $_REQUEST['btntype'];

if (!isset($btntype) || ($btntype == "")) { 
	$btntype = $_SESSION['btntype'];
}
								 
logToFile("checkout.php: btntype=".$btntype,LOG_DEBUG_DAP);	
logToFile("checkout.php: session btntype=".$_SESSION['btntype'],LOG_DEBUG_DAP);	


if ((!isset($btntype)) || ((isset($btntype) && strcmp($btntype, 'buynow') != 0))) { 
	$productId = -1;
}

logToFile("checkout.php: productId=".$productId,LOG_DEBUG_DAP);	


logToFile("checkout.php: current session amount=".$_SESSION['new_amount'],LOG_DEBUG_DAP);	

if (($_REQUEST['is_submitted'] == "Y") && (strcmp($btntype, 'buynow') == 0)) {
  unset($_SESSION['new_amount']);
  unset($_SESSION['couponCode']);
  unset($_SESSION['num_cart']);
}

logToFile("checkout.php: new session amount=".$_SESSION['new_amount'],LOG_DEBUG_DAP);	

if ((!$_SESSION['num_cart']) || ($_SESSION['num_cart'] == 0) || isset($item_name)) {
	
	if(!isset($item_name)) {
		$error_url = "Sorry, missing item_name";
		return $error_url;
	}
	
	logToFile("checkout: item_name" .$item_name, LOG_DEBUG_DAP);
	
	if ($btntype == "buynow") {	
		$product = Dap_Product::loadProductByName(trim($item_name));
		
		$productId = $product->getId();
		
		logToFile("checkout: productId" .$productId, LOG_DEBUG_DAP);
		$item_name = $product->getName();
		$description = $product->getDescription();
		
		$trial_amount = $product->getTrial_price();
		$amount = $product->getPrice();
		
		$is_recurring = $product->getIs_recurring();
		
		$recurring_cycle_1 = $product->getRecurring_cycle_1();
		$recurring_cycle_2 = $product->getRecurring_cycle_2();
		$recurring_cycle_3 = $product->getRecurring_cycle_3();
		$total_occurrences = $product->getTotal_occur();
			
				
		$discount_amt = "";
		$recurring_discount_amt = "";
		$initial_amount = "";
		$initial_trial_amount = "";
		
		logToFile("validateCoupon: couponCode" .$_SESSION['couponCode'], LOG_DEBUG_DAP);
		
		if ($_SESSION['couponCode'] != "") {
			$couponCode = $_SESSION['couponCode'];
			$coupon = Dap_Coupon::loadCouponByCode($couponCode); //loads coupon details from db
			if (isset($coupon)) {
				$post['coupon_id'] = $coupon->getId();
				logToFile("functions_payment.php: set coupon Id = " . $post['coupon_id']);
				$discount_amt = $coupon->getDiscount_amt();
				$recurring_discount_amt = $coupon->getRecurringDiscount_amt();
				
				if ($is_recurring == "Y") {
					if ($product->getTrial_price() > 0) {
						$trial_amount = $product->getTrial_price() - $discount_amt;
					}
					else {
						$trial_amount  = $product->getPrice() - $discount_amt;
					}
		
					$amount  = $product->getPrice();
					if ($recurring_discount_amt > 0) {
						$amount = $product->getPrice() - $recurring_discount_amt;
					}
				}
				else {	
					$amount  = $product->getPrice() - $discount_amt;	
				}
				
				logToFile("validateCoupon.php: subscription: trial=" . $product->getTrial_price());
				logToFile("validateCoupon.php: subscription: actual product price =" . $product->getPrice());
				logToFile("validateCoupon: subscription: final discounted initial amount=" . $trial_amount);
			
				logToFile("validateCoupon: subscription: recurring_discount_amt=" . $recurring_discount_amt);
				logToFile("validateCoupon: subscription: final recurring discounted amount=" . $amount);
			}
		}
		
		logToFile("validateCoupon.php: subscription: trial=" . $product->getTrial_price());
		
		//$trialPrice = intval($trial_amount);		
		
		if ($trial_amount > 0) {
			$display_amount=$trial_amount;
				
			logToFile("checkout.php: display_amount: " . $display_amount);
		}
		else {
			$display_amount=$amount;
			$trial_amount = "0.00";
		}
		
		
	}

}

$user = Dap_User::loadAdminUserByMinId();
if (!isset($user)) {
		$error_url = "Sorry, Admin setup issue. Please contact the site-admin";
		return $error_url;
}
	
$password = $user->getPassword();
if (!isset ($password) || $password == '') {
	$error_url = "Sorry, Admin setup issue. Please contact the site-admin";
	return $error_url;
}

$_SESSION['password'] = $password;

if (isset($_POST['payment_gateway'])) {
	logToFile("checkout.php: set payment gateway=".$_POST['payment_gateway'],LOG_DEBUG_DAP);	
	$_SESSION['payment_gateway'] = $_POST['payment_gateway'];
	$payment_gateway = $_SESSION['payment_gateway'];
}

// cart options
$tandc = "";
$show_coupon = "N";
$show_address2 = "N";
$show_howdidyouhearboutus = "N";
$show_shiptoaddress = "N";

$show_tandc = "N";
$require_tandc_acceptance = "N";
$request_phone = "N";
$request_fax = "N";
$request_address2 = "N";
$request_company = "N";
$show_comments = "N";
$cart_header = "";
$cart_footer = "";
$checkout_submit_image_url = "N";


$productCartOptions = Dap_CartOption::loadProductCartOptions($productId);
if(isset($productCartOptions)) {
	
	// cart options
	
	$show_coupon = $productCartOptions->getShowCouponCode();
	$show_howdidyouhearboutus = $productCartOptions->getHowDidYouHear();
	$show_shiptoaddress = $productCartOptions->getShowShipAddress();
	$show_address2 = $productCartOptions->getRAddress2();
	
	$show_tandc = $productCartOptions->getShowTAndC();
	$tandc = $productCartOptions->getTAndC();
	$require_tandc_acceptance = $productCartOptions->getRTAndC();
	$request_phone = $productCartOptions->getRPhone();
	$request_fax = $productCartOptions->getRFax();
	$request_address2 = $productCartOptions->getRAddress2();
	$request_company = $productCartOptions->getRCompany();
	$show_comments = $productCartOptions->getShowComments();
	$cart_header = $productCartOptions->getCartHeader();
	$cart_footer = $productCartOptions->getCartFooter();
	$checkout_submit_image_url = $productCartOptions->getSubmitOrderImage();
	
	logToFile("checkout.php: require_tandc_acceptance=".$require_tandc_acceptance,LOG_DEBUG_DAP);	
}
else {
	logToFile("checkout.php: empty table",LOG_DEBUG_DAP);	
}
		
?>
<?php getCheckoutCss(); ?>
<link rel='stylesheet' type='text/css' href='/dap/inc/content/dap.css'>
<link rel='stylesheet' type='text/css' href='/dap/inc/content/PaymentForm.css'>
<script type='text/javascript' language='javascript' src="/dap/javascript/country-state.js"></script>
<script type='text/javascript' language='javascript' src="/dap/javascript/common.js"></script>
<script type='text/javascript' language='javascript' src="/dap/javascript/paymentvalidation.js"></script>
<script type="text/javascript" language="javascript">
	function initCardType() {
		var cardtype = document.getElementById('card_type');
		if (cardtype != null) {
			var val = 
			"<?php 
				if (isset($_SESSION['paymentObj'])) {
					$cardt = $_SESSION['paymentObj']->getCard_type(); 
					if ($cardt != '')
					{ 
						echo $cardt; 
					}
					else echo '';
				}
			?>";
		
			if (val != null && val != '') {
                //cardtype.options[cardtype.selectedIndex].text = val;
            for(i=0; i<cardtype.options.length; i++) {
               if(cardtype.options[i].value == val) {
                    cardtype.selectedIndex = i;
               }
            }
         }
			
		}
	}
	
	function applyCoupon(form) {
	
		if (form.coupon_code.value == null || form.coupon_code.value == "") {
			alert("Please enter coupon code");	
			form.coupon_code.focus();
			return;
		}
	// use coupon code to get discount amount
					
		form.action = "<?php echo '/dap/inc/validateCoupon.php'; ?>";
		form.submit();		

	
	}
		
</script>
<?php if(isset($cart_header)) echo $cart_header;?>
<center>
  <div id="checkoutPage" style="border: #828282 1px solid; padding: 5px; width:600px; text-align:left;">
    <!-- Error Text Div -->
    <div id="errorText">
		<?php 
            if (isset($item_name) && ($item_name != "")) {
                $_SESSION['couponCode'] = NULL;
            }
                     
                
            if ((isset($_SESSION['err_text'])) || (isset($_REQUEST['err_text']))) {	
                logToFile("CHECKOUT.php: session=" . $_SESSION['err_text'],LOG_DEBUG_DAP);
                logToFile("CHECKOUT.php: request=" . $_REQUEST['err_text'],LOG_DEBUG_DAP);
                if ($_SESSION['err_text'])
                    echo "ERROR: " . $_SESSION['err_text']; 
                else 
                    echo "ERROR: " . $_REQUEST['err_text']; 
                    
                unset($_SESSION['err_text']);
                $_SESSION['err_text']=NULL;
            }
      
            
        ?>
	</div>
    <div id="checkoutPageHeader" align="center">
        <p align="right"><img src="/dap/images/secure-padlock.gif"><span class="Comment"><a id="aCardCodeWhatsThis" href="/dap/inc/content/secure.html" onclick='javascript:return PopupLink(this);'>Your order is secure</a></span></p>
    </div>
    <!-- END: Error Text Div -->
    <form name="formPayment" id="formPayment" autocomplete="off" method="post" action="/dap/checkout-submit.php">
      <!-- Product Information Div -->
      <?php if( (isset($_REQUEST['btntype']) && (strcmp($_REQUEST['btntype'], 'buynow') == 0)) || (isset($_SESSION['btntype']) && (strcmp($_SESSION['btntype'], 'buynow') == 0))){ 
			logToFile("CHECKOUT.php: display product info?, session=" . $_SESSION['num_cart'],LOG_DEBUG_DAP);
	  ?>
      <fieldset>
        <legend>Product Information</legend>
        <div id="divOrderDetailsTop" width="100%">
          <table id="tableOrderDetailsTop">
            <tr valign="top">
              <td nowrap class="LabelColOrderTop"><div align="left">Product:</div></td>
              <td class="DataColOrderTop"><div align="left"><?php echo $item_name; ?></div></td>
            </tr>
            <tr valign="top">
              <td nowrap class="LabelColOrderTop"><div align="left">Description: </div></td>
              <td class="DataColOrderTop"><div align="left"><?php echo $description; ?> &nbsp;<br/>
              </div></td>
            </tr>
            <?php if (($show_coupon != "Y")) { ?>
            <tr valign="top">
              <td align="right" class="DataColOrderTop" colspan="2"><h3><div align="right">Total: 
  				<?php echo "$ " . $display_amount; 
				?>
              </h3></div></td>
            </tr>
            <?php } else { ?>
            <tr valign="top">
              <td nowrap class="LabelColOrderTop" colspan="2"><div align="left"><strong>Coupon:</strong> 
                 <input type="text" id="coupon_code" name="coupon_code" size="6" title="Optional" value="(optional)" onFocus="clearDefaultText(this.form);"  onBlur="resetDefaultText(this.form);"> 
                <input type="button" class="couponbtn" id="apply_coupon" onclick='applyCoupon(document.formPayment);' value='Apply'>
 				</div>
              </td>
            </tr>
            <tr valign="top">
              <td align="right" class="DataColOrderTop" colspan="2"><h3><div align="right">Total: 
  				<?php
					$amt = 0;
					if ($_SESSION['new_amount'] != "") {
						$amt = $_SESSION['new_amount'];
					}
					else  {	
						$amt = $display_amount;
					} 
					echo "$ " . $amt; 
				?>
              </h3></div></td>
            </tr>
            <?php } ?>
          </table>
          <!-- tableOrderDetailsTop -->
        </div>
      </fieldset>
      <!-- END: Product Information Div -->
      <?php } ?>
      <!-- Payment Information Div -->
      <fieldset>
        <legend>Payment Information</legend>
        <div id="divCreditCardInformation" width="100%">
          <table id="tableCreditCardInformation">
            <tr id="trAcceptedCardImgs">
              <td class="LabelColCC">&nbsp;</td>
              <td><div align="left"><img border="0" src="/dap/images/V.gif" width="43" height="26" title="Visa" alt="Visa"></img> <img border="0" src="/dap/images/MC.gif" width="41" height="26" title="MasterCard" alt="MasterCard"></img></div></td>
            </tr>
            <?php if ($payment_gateway == "paypal") {
				echo "<tr>";
				echo "<td valign='top' class='LabelColCC'>Card Type:&nbsp;</td>";
				echo "<td valign='top'>";
				echo "<select id='card_type' name='card_type' style='width: 190px;font-size: 14px;'>";
				echo "<option value='Visa' selected>Visa</option>";
				echo "<option value='MasterCard'>MasterCard</option>";
				echo "<option value='Discover'>Discover</option>";
				echo "<option value='Amex'>American Express</option>";
				echo "</select>	</td> </tr>";
			}
			?>
            <tr>
              <td valign="top" class="LabelColCC"><div align="left">* Card Number: </div></td>
              <td valign="top"><div align="left">
                <input type="text" id="card_num" name="card_num" maxlength="16" size="18" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getCard_num(); ?>" >
                &nbsp;<span class="Comment">(no spaces/dashes)</span></div></td>
            </tr>
            <tr>
              <td valign="top" nowrap class="LabelColCC"><div align="left">* Expiration Date: </div></td>
              <td valign="top"><div align="left">
                <input type="text" id="exp_date" name="exp_date" maxLength="4" size="4" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getExp_date(); ?>" >
                &nbsp;<span class="Comment">(mmyy)</span></div></td>
            </tr>
            <tr>
              <td valign="top" class="LabelColCC"><div align="left">* Card Code: </div></td>
              <td valign="top"><div align="left">
                <input type="text" id="card_code" name="card_code" maxLength="4" size="4" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getCard_code(); ?>" >
                &nbsp;<span class="Comment"><a id="aCardCodeWhatsThis" href="/dap/Card_Code.html" target=_blank onclick='javascript:return PopupLink(this);'>What's this?</a></span></div></td>
            </tr>
          </table>
          <!-- tableCreditCardInformation -->
        </div>
      </fieldset>
      <!-- Billing Information Div -->
      <fieldset>
        <legend>Billing Information</legend>
        <div id="divBillingInformation" align="left" width='100%'>
          <table id="tableCustomerBillingInformation">
            <tr>
              <td class="LabelColBill"><div align="left">* First Name: &nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="first_name" name="first_name" maxLength="50" size="20" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getFirst_name(); ?>" >
              </div></td>
            </tr>
            <tr>
              <td class="LabelColBill"><div align="left">* Last Name:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="last_name" name="last_name" maxLength="50" size="20" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getLast_name(); ?>" >
              </div></td>
            </tr>
            <tr>
              <td class="LabelColBill"><div align="left">* Address:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="address" name="address" maxLength="100" size="30" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getAddress1(); ?>" >
              </div></td>
            </tr>
            <?php 
				if ($show_address2 == "Y") {
				?>
            <tr>
              <td class="LabelColBill"><div align="left">* Address2:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="address2" name="address2" maxLength="100" size="30" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getAddress2(); ?>" >
              </div></td>
            </tr>
            <?php 
				}
				?>
            <tr>
              <td class="LabelColBill"><div align="left">* City:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="city" name="city" maxLength="100" size="30" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getCity(); ?>" >
              </div></td>
            </tr>
            <tr>
              <td class="LabelColBill"><div align="left">State/Province:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <select name='state' id='state' STYLE="width: 190px;font-size: 14px;">
                </select>
              </div></td>
            </tr>
            <tr>
              <td nowrap class=LabelColShip><div align="left">* Zip/Postal Code:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="zip" name="zip" maxLength="10" size="20" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getZip();?>">
              </div></td>
            </tr>
            <tr>
              <td class="LabelColBill"><div align="left">* Country:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <select id="country" name="country" STYLE="width: 190px;font-size: 14px;" onChange="if (document.getElementById('countryvar').value == '') populateState('country', 'state', '', '', '')">
                </select>
              </div></td>
              <script type="text/javascript"> 
					var inits ='<?php if (isset($_SESSION['statevar'])) echo $_SESSION['statevar']; else echo ""; ?>';
					var initc= '<?php if (isset($_SESSION['countryvar'])) echo $_SESSION['countryvar']; else echo ""; ?>';
					var initccode= '<?php if (isset($_SESSION['countrycode'])) echo $_SESSION['countrycode']; else echo ""; ?>';
					
					initCountry("US", "country", "state", initc, inits, initccode); 
				</script>
            </tr>
            <tr>
              <td class="LabelColBill"><div align="left">* Email:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="email" name="email" maxLength="255" size="30" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getEmail(); ?>" >
              </div></td>
            </tr>
            <?php 
		if ($request_phone == "Y") {
		?>
            <tr>
              <td class="LabelColBill"><div align="left">* Phone:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="phone" name="phone" maxLength="25" size="20" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getPhone(); ?>" >
              </div></td>
            </tr>
            <?php }	?>
            <?php 
		if ($request_fax == "Y") {
		?>
            <tr>
              <td class="LabelColBill"><div align="left">Fax:&nbsp;&nbsp;</div></td>
              <td class="DataColBill"><div align="left">
                <input type="text" id="fax" name="fax" maxLength="25" size="20" value="<?php if (	$_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getFax(); ?>" >
                &nbsp;<span class=Comment></span></div></td>
            </tr>
            <?php }	?>
          </table>
          <!-- tableCustomerBilling -->
        </div>
      </fieldset>
      <?php 
	if ($show_shiptoaddress == "Y") {
	?>
      <!-- divBillingInformation -->
      <fieldset>
        <legend>Shipping Information</legend>
        <br/>
        <p>
          <input type="checkbox" id="chkCopyBill" onClick="showHideShippingDiv(this.form);">
          &nbsp;Ship to a different address?</p>
        <div id="divShippingInformation" align="left" width='100%' style="display:none">
          <table id=tableCustomerShippingInformation>
            <tr id="trChkCopyBill">
              <td colspan="2"></td>
            </tr>
            <tr>
              <td class="LabelColBill">First Name: </td>
              <td class="DataColBill"><input type="text" id="ship_to_first_name" name="ship_to_first_name" maxLength="50" size="14" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_first_name(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColBill">Last Name: </td>
              <td class="DataColBill"><input type="text" id="ship_to_last_name" name="ship_to_last_name" maxLength="50" size="14" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_last_name(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColShip">Address: </td>
              <td class="DataColShip"><input type="text" id="ship_to_address" name="ship_to_address" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_address1(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <?php 
				if ($show_address2 == "Y") {
				?>
            <tr>
              <td class="LabelColShip">Address2: </td>
              <td class="DataColShip"><input type="text" id="ship_to_address2" name="ship_to_address2" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_address2(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <?php } ?>
            <tr>
              <td class="LabelColShip">City: </td>
              <td class="DataColShip"><input type="text" id="ship_to_city" name="ship_to_city" maxLength="100" size="43" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_city(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColShip">State/Province: </td>
              <td class="DataColShip"><select id="ship_to_state" name="ship_to_state"  STYLE="width: 190px;font-size: 14px;" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_state(); ?>" >
                </select>
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td align="right" class="LabelColShip">&nbsp;&nbsp;Zip/Postal Code: &nbsp;</td>
              <td class="DataColShip"><input type="text" id="ship_to_zip" name="ship_to_zip" maxLength="10" size="10" value="<?php if ($_SESSION['paymentObj'] != null) echo $_SESSION['paymentObj']->getShip_to_zip(); ?>" >
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <tr>
              <td class="LabelColShip">Country: </td>
              <td class="DataColShip"><select id="ship_to_country" name="ship_to_country" STYLE="width: 190px;font-size: 14px;" onChange="populateState('ship_to_country', 'ship_to_state','','','')">
                </select>
                *&nbsp;<span class=Comment></span></td>
            </tr>
            <script type="text/javascript"> 
					var initship ='<?php if (isset($_SESSION['shipstatevar'])) echo $_SESSION['shipstatevar']; else echo ""; ?>';
					var initcountry = '<?php if (isset($_SESSION['shipcountryvar'])) echo $_SESSION['shipcountryvar']; else echo ""; ?>';
					var initcountrycode = '<?php if (isset($_SESSION['shipcountrycode'])) echo $_SESSION['shipcountrycode']; else echo ""; ?>';
					initCountry("US", "ship_to_country", "ship_to_state", initcountry, initship, initcountrycode);
					
			</script>
          </table>
          <!-- tableCustomerShippingInformation -->
        </div>
      </fieldset>
      <?php } ?>
      <!-- Product Information Div -->

   <?php 
		if ($show_howdidyouhearboutus == "Y") { 
			logToFile("CHECKOUT.php: display how did you find out about us info?",LOG_DEBUG_DAP);
	?>
      <fieldset>
        <legend>Additional Information</legend>
        <div id="divAdditionalInfoTop">
          <p class="LabelColOrderTop">How did you hear about us?<br/>
              <textarea name="howdidyouhearaboutus" rows="4" cols="20"></textarea>
          </p>
         </div>
      </fieldset>

      <?php } ?>
      <?php 
		if ($show_comments == "Y") { 
			logToFile("CHECKOUT.php:comments?",LOG_DEBUG_DAP);
	?>
      <fieldset>
        <legend>Comments</legend>
        <div id="divAdditionalInfoTop">
        	<p class="DataColOrderTop"><textarea name="comments" rows="4" cols="43" ></textarea></p>
        </div>
      </fieldset>

      <?php } ?>
      <?php 
	
		if ($show_tandc == "Y") { 
			logToFile("CHECKOUT.php: display how did you find out about us info?",LOG_DEBUG_DAP);
	  ?>
      <fieldset>
        <legend>Terms And Conditions</legend>
        <div id="divTandC">
            <p class="DataColOrderTop" align="left"><textarea name="tandctext" rows="4" cols="30" readonly><?php echo $tandc ?></textarea></p>
            <p class="LabelColOrderTop" align="left">
            	<input type="checkbox" align="right" name="tandc" id="tandc"> <strong> I accept these terms and conditions </strong>
            </p>
        </div>
      </fieldset>
      <?php } ?>
      <br>
      <!-- divShippingInformation -->
      <!-- divShippingInformation -->
      <fieldset>
        <legend>Security Code</legend>
        <!-- pass a session id to the query string of the script to prevent ie caching -->
        <div id="divCaptcha">
            <p class="DataColCaptcha" align="left"><img id="x_captcha_signature" name="x_captcha_signature" src="/dap/securimage_show.php?sid=<?php echo md5(uniqid(time())); ?>"></p>
            <p class="DataColCaptcha" align="left">
            	<strong>* Enter security code above: </strong> <input name="code" type="text" value = "" size = "5" maxlength = "5"/>
            </p>
            <p><a href="#" onClick="document.getElementById('x_captcha_signature').src = '/dap/securimage_show.php?sid=' + Math.random(); return false">Reload Image</a></p>
        </div>
      </fieldset>
      <!-- divCaptcha -->
      
      <p>&nbsp;</p>
      <table id=tableButtons width='100%'>
        <tr>
          <td width="130">
            <div align="left">
              <input type=reset class="resetbtn" id=btnReset onclick='return reset_onClick();' value='Reset Form' tabindex="1">
            </div></td>
          <td><div align="right">
              <?php 
					if (($checkout_submit_image_url != "N") && ($checkout_submit_image_url != "")) {
						logToFile("checkout.php:checkout_submit_image_url=" . $checkout_submit_image_url);
			
					?>
					<input type="image" name="btnSubmit" id="btnSubmit" onclick="if(onSubmit(document.formPayment) == false) return false; else return true;" src="<?php echo $checkout_submit_image_url; ?>" >
				<?php	} 
					else { 
						logToFile("checkout.php:checkout_submit_image_url is empty " . $checkout_submit_image_url);
					?>
					  <input name="btnSubmit" type="button" class="submitbtn" id="btnSubmit" onclick='onSubmit(this.form);' value = 'Submit Order' tabindex="0">
              <?php } ?>
            </div></td>
        </tr>
      </table>
      <input type="hidden" name="btntype" value="<?php echo $btntype; ?>">
      <input type="hidden" name="description" value="<?php echo $description; ?>">
      <input type="hidden" name="item_name" value="<?php echo $item_name; ?>">
      <input type="hidden" name="product_id" value="<?php echo $productId; ?>">
      <input type="hidden" name="cmcc_acctnum" value="<?php echo $cmcc_acctnum; ?>">
      <input type="hidden" name="payment_gateway" value="<?php echo $payment_gateway; ?>">
      <input type="hidden" name="payment_succ_page" value="<?php echo $payment_succ_page; ?>">
      <input type="hidden" name="payment_err_page" value="<?php echo $payment_err_page; ?>">
      <input type="hidden" name="amount" value="<?php echo $amount; ?>">
      <input type="hidden" name="trial_amount" value="<?php echo $trial_amount; ?>">
      <input type="hidden" name="total_occurrences" value="<?php echo $total_occurrences; ?>">
      <input type="hidden" name="invoice" value="<?php echo $invoice; ?>">
      <input type="hidden" name="is_recurring" value="<?php echo $is_recurring; ?>">
      <input type="hidden" name="recurring_cycle_1" value="<?php echo $recurring_cycle_1; ?>">
      <input type="hidden" name="recurring_cycle_2" value="<?php echo $recurring_cycle_2; ?>">
      <input type="hidden" name="recurring_cycle_3" value="<?php echo $recurring_cycle_3; ?>">
      <input type="hidden" name="testmode" value="<?php echo $testmode; ?>">
      <input type="hidden" id='cardtype' name="cardtype" value="">
      <input type="hidden" id='statevar' name="statevar" value="">
      <input type="hidden" id='statecode' name="statecode" value="">
      <input type="hidden" id='countryvar' name="countryvar" value="">
      <input type="hidden" id='countrycode' name="countrycode" value="">
      <input type="hidden" id='shipstatevar' name="shipstatevar" value="">
      <input type="hidden" id='shipstatecode' name="shipstatecode" value="">
      <input type="hidden" id='shipcountryvar' name="shipcountryvar" value="">
      <input type="hidden" id='shipcountrycode' name="shipcountrycode" value="">
      <input type="hidden" id='tandc_acceptance' name="tandc_acceptance" value='<?php 	
	logToFile("checkout.php: hidden require_tandc_acceptance=".$require_tandc_acceptance,LOG_DEBUG_DAP); echo $require_tandc_acceptance; ?>'>
      <input type="hidden" name="is_submitted" value="<?php echo $is_submitted; ?>">
      <input type="hidden" name="redirect" value="<?php echo $_SERVER['PHP_SELF']; ?>">
      <input type="hidden" name="err_redirect" value="<?php echo $_SERVER['REQUEST_URI']; ?>">
    </form>
  </div>
  <!-- entire BODY -->
</center>
<?php if(isset($cart_footer)) echo $cart_footer;?>

<script language="javascript">
	onPageLoad();
	//enableButton(document.getElementById('btnSubmit'),'Submit Order');
</script>