<?php
	include_once ("dap-config.php");
	
	$myval = 'cmd=_notify-validate';
	foreach ($_POST as $key => $value) {
		$value = urldecode(stripslashes($value));
		$myval .= "&$key=$value";
		logToFile("Silent Post Response" . $key . "=" . $value, LOG_DEBUG_DAP);
	}
	
	if(file_exists("authnetmultisite.php")) include ("authnetmultisite.php"); 
	
	$response_code = $_POST['x_response_code'];
	$response_msg = urldecode($_POST['x_response_reason_text']);
	$payer_email = urldecode($_POST['x_email']);
	
	if($response_code != '1'){
		if (isset ($_POST['x_subscription_id']) )
			$error_str = "dap-silentpost: authorize.net recurring payment declined for the buyer: " . $payer_email. " with response code=" . $response_code . ", error text=" . 	$response_msg;
		else 
			$error_str = "dap-silentpost: authorize.net AIM payment declined for the buyer: " . $payer_email. " with response code=" . $response_code . ", error text=" . 	$response_msg;
			
		logToFile($error_str, LOG_DEBUG_DAP);
		sendAdminEmail($error_str, $error_str);
		return;
	}
	
	// if $_POST['x_subscription_id'] is set, it indicates an ARB transaction
	if (isset ($_POST['x_subscription_id']) ){
		$arb=TRUE;
		logToFile("dap-silentpost: authorize.net ARB payment arrived for buyer: " . $payer_email . " with subscription_id=" . $_POST['x_subscription_id'] . ", invoice=" . $_POST['x_invoice'], LOG_DEBUG_DAP);
	} else {
		logToFile("dap-silentpost: authorize.net payment arrived for buyer: " . $payer_email . ", check if AIM... invoice=" . $_POST['x_invoice'], LOG_DEBUG_DAP);
	}
	
	$req = 'cmd=_notify-validate';
	foreach ($_POST as $key => $value) {
	  $value = urldecode(stripslashes($value));
	  $req .= "&$key=$value";
	}
	
	logToFile("Silent authnet response" . $req, LOG_DEBUG_DAP);
	
	$result = array();
	
	$result['response_reason_code'] = $_POST['x_response_reason_code'];
	$result['text'] = $_POST['x_response_reason_text'];
	$result['approval_code'] = $_POST['x_auth_code'];
	$result['avs_result_code'] = $_POST['x_avs_code'];
	
	$result['response_code'] = $_POST['x_response_code'];
	
	$result['md5_hash'] = $_POST['x_MD5_Hash'];
	
	$result['sub_id'] = $_POST['x_subscription_id'] . ":" . $_POST['x_subscription_paynum'];
	$result['payment_num'] = $_POST['x_subscription_paynum'];
	
	$result['amount'] = $_POST['x_amount'];
	$result['type'] = $_POST['x_type'];
	$result['email'] = $_POST['x_email'];
	
	if (($_POST['x_test_request'] == "true") && ($_POST['x_trans_id'] == "0")) {
		$result['txn_id'] =  $_POST['x_invoice_num'] . ":0"; 
	}
	else if ($arb) {
		$result['txn_id'] = $_POST['x_trans_id'] . ":" . $_POST['x_subscription_paynum'];
		logToFile("dap-silentpost: ARB transacion_ID=" . $result['txn_id'], LOG_DEBUG_DAP);
		logToFile("dap-silentpost: ARB item description=" . $_POST['x_description'], LOG_DEBUG_DAP);
	}
	else {
		$result['txn_id'] = $_POST['x_trans_id'] . ":0"; 
	}
	
	$result['item_name'] = $_POST['x_description'];
	
	$result['payer_email'] = urldecode($_POST['x_email']);
	
	$result['txn_type'] = $_POST['x_type'];
	
	if ((isset($result['txn_type'])) && (strcmp($result['txn_type'],"CREDIT") == 0)) {
		$error_str = "dap-silentpost: authorize.net notification received with transacion type of " . $result['txn_type'] . ". DAP only processes AUTH_CAPTURE notification - successful payment notification. DAP does not process refund notification or other types of notifications from authnet. No action taken for this notification from authnet for user=" . $payer_email;
			
		logToFile($error_str, LOG_DEBUG_DAP);
		sendAdminEmail($error_str, $error_str);
		return;
	}
	
	$payObj = new Dap_Payment();
	$payObj->setEmail (urldecode($_POST['x_email']));
	$payObj->setPhone ($_POST['x_phone']);
	$payObj->setFax ($_POST['x_fax']);
	
	//store billing info
	$payObj->setFirst_name ($_POST['x_first_name']);
	$payObj->setLast_name ($_POST['x_last_name']);
	$payObj->setAddress1 ($_POST['x_address']);
	$payObj->setCity ($_POST['x_city']);
	$payObj->setState ($_POST['x_state']);
	$payObj->setZip ($_POST['x_zip']);
	$payObj->setCountry ($_POST['x_country']);
	
	//store shipping info
	$payObj->setShip_to_first_name ($_POST['x_ship_to_first_name']);
	$payObj->setShip_to_last_name ($_POST['x_ship_to_last_name']);
	$payObj->setShip_to_address1 ($_POST['x_ship_to_address']);
	$payObj->setShip_to_city ($_POST['x_ship_to_city']);
	$payObj->setShip_to_state ($_POST['x_ship_to_state']);
	$payObj->setShip_to_zip ($_POST['x_ship_to_zip']);
	$payObj->setShip_to_country ($_POST['x_ship_to_country']);
	
	if (!($payObj->processAuthnetResponse ($result, "Silent Post")))
	{ 
		logToFile("dap-silentpost: Silent Response... Dap_Payment failed to process", LOG_DEBUG_DAP);
	}
	else {
		logToFile("dap-silentpost: Silent Response... successfully processed", LOG_DEBUG_DAP);
	}

?>