<?php 
	/*	  1. read product info from products
	2. read post params into variables
	3. if missing form input, replace from products
	4. if no session, display form with pre-filled values and editable text box
	5. if session, submit to paymentsubmit.php*/
	
	$is_submitted = isset($_POST['is_submitted']) ? $_POST['is_submitted'] : "N";
	
	if (isset($_POST['payment_succ_page'])) {
		$payment_succ_page = $_POST['payment_succ_page'];
	}
	else if ($is_submitted == "N" && isset($_SESSION['payment_succ_page'])) {
		$payment_succ_page = $_SESSION['payment_succ_page'];
		unset($_SESSION["payment_succ_page"]);
	}
	else {
		$payment_succ_page = SITE_URL_DAP."/dap/paymentSuccess.php";
		$payment_succ_page= str_replace ( "http:", "https:", $payment_succ_page );
	}
	
	if (isset($_POST['payment_err_page'])) {
		$payment_err_page = $_POST['payment_err_page'];
	}
	else if ($is_submitted == "N" && isset($_SESSION['payment_err_page'])) {
		$payment_err_page = $_SESSION['payment_err_page'];
		unset($_SESSION["payment_err_page"]);
	}
	else {
		$payment_err_page = SITE_URL_DAP."/dap/paymentError.php";
		$payment_err_page= str_replace ( "http:", "https:", $payment_err_page );
	}
	
	if (isset($_POST['payment_gateway']) && $_POST['payment_gateway'] != '') {
		$payment_gateway = $_POST['payment_gateway'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['payment_gateway'])) {
		$payment_gateway = $_SESSION['payment_gateway'];
		unset($_SESSION["payment_gateway"]);
	}
	else {
		$error_url = $payment_err_page."?response_msg=missing payment_gateway param";
		logToFile("Dap_Payment:setSessionParams(). error page redirect: " . $error_url, LOG_DEBUG_DAP);
		header("Location: " . $error_url);
		return;
	}
	
	if (isset($_POST['item_name']) && $_POST['item_name'] != '') {
		$item_name = $_POST['item_name'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['item_name'])) {
		$item_name = $_SESSION['item_name'];
		unset($_SESSION["item_name"]);
	}
	else {
		$error_url = $payment_err_page."?response_msg=missing item_name param";
		header("Location: " . $error_url);	
		return;
	}
	
	if (isset($_POST['description']) && $_POST['description'] != '') {
		$description = $_POST['description'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['description'])) {
		$description = $_SESSION['description'];
		unset($_SESSION["description"]);
	}
	
	if (isset($_POST['amount']) && $_POST['amount'] != '') {
		$amount = $_POST['amount'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['amount'])) {
		$amount = $_SESSION['amount'];
		unset($_SESSION["amount"]);
	}
	else {
		$error_url = $payment_err_page."?response_msg=missing amount param";
		header("Location: " . $error_url);	
		return;
	}
	
	if (isset($_POST['trial_amount']) && $_POST['trial_amount'] != '') {
		$trial_amount = $_POST['trial_amount'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['trial_amount'])) {
		$trial_amount = $_SESSION['trial_amount'];
		unset($_SESSION["trial_amount"]);
	}

	if (isset($trial_amount) && $trial_amount != '' && $trial_amount != "0.00" && $trial_amount != "0.0" && $trial_amount != "0" ) {
		$display_amount=$trial_amount;
	}
	else {
		$display_amount=$amount;
		$trial_amount = "0.00";
	}
	
	$invoice = date(YmdHis);	
	
	if (isset($_POST['total_occurrences']) && $_POST['total_occurrences'] != '') {
		$total_occurrences = $_POST['total_occurrences'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['total_occurrences'])) {
		$total_occurrences = $_SESSION['total_occurrences'];
		unset($_SESSION["total_occurrences"]);
	}
	else {
		$error_url = $payment_err_page."?response_msg=missing total_occurrences param";
		header("Location: " . $error_url);	
		return;
	}

	if (isset($_POST['is_recurring']) && $_POST['is_recurring'] != '') {
		$is_recurring = $_POST['is_recurring'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['is_recurring'])) {
		$is_recurring = $_SESSION['is_recurring'];
		unset($_SESSION["is_recurring"]);
	}
	else {
		$error_url = $payment_err_page."?response_msg=missing is_recurring param";
		header("Location: " . $error_url);	
		return;
	}
	
	if (isset($_POST['recurring_cycle_1']) && $_POST['recurring_cycle_1'] != '') {
		$recurring_cycle_1 = $_POST['recurring_cycle_1'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['recurring_cycle_1'])) {
		$recurring_cycle_1 = $_SESSION['recurring_cycle_1'];
		unset($_SESSION["recurring_cycle_1"]);
	}
	
	if (isset($_POST['recurring_cycle_2']) && $_POST['recurring_cycle_2'] != '') {
		$recurring_cycle_2 = $_POST['recurring_cycle_2'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['recurring_cycle_2'])) {
		$recurring_cycle_2 = $_SESSION['recurring_cycle_2'];
		unset($_SESSION["recurring_cycle_2"]);
	}
	
	if (isset($_POST['recurring_cycle_3']) && $_POST['recurring_cycle_3'] != '') {
		$recurring_cycle_3 = $_POST['recurring_cycle_3'];
	}
	else if (($is_submitted == "N") && isset($_SESSION['recurring_cycle_3'])) {
		$recurring_cycle_3 = $_SESSION['recurring_cycle_3'];
		unset($_SESSION["recurring_cycle_3"]);
	}
	
	if (isset($is_recurring) && $is_recurring == "Y" && ($recurring_cycle_1 == '' || $recurring_cycle_3 == '' || $total_occurrences == '')) {
		
		$error_url = $payment_err_page."?response_msg=missing recurring_cycle_1 or recurring_cycle_3 or total_occurrences param";
		header("Location: " . $error_url);	
		return;
	}
	
?>
